//
//  ObjcRed5proPlugin.m
//  red5pro
//
//  Created by Jaydip Godhani on 22/11/21.
//

#import "ObjcRed5proPlugin.h"
#import "Red5StreamViewFactory.h"
#import "Red5StreamPlayerViewFactory.h"

@implementation ObjcRed5proPlugin

+(void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:@"red5pro" binaryMessenger:registrar.messenger];
    ObjcRed5proPlugin* instance = [[ObjcRed5proPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
    
    //// Red5Pro Streaming view
    Red5StreamViewFactory* factoryStreaming = [[Red5StreamViewFactory alloc] initWithMessenger:registrar.messenger];
    [registrar registerViewFactory:factoryStreaming withId:@"Red5StreamView"];
    
    //// Red5Pro Streaming Player view
    Red5StreamPlayerViewFactory* factoryPlayer = [[Red5StreamPlayerViewFactory alloc] initWithMessenger:registrar.messenger];
    [registrar registerViewFactory:factoryPlayer withId:@"Red5StreamPlayerView"];
}

-(void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSLog(@"IOS call back from method channel");
}

@end
