//
//  Red5ProStreamPlayerController.m
//  red5pro
//
//  Created by Jaydip Godhani on 23/11/21.
//

#import "Red5ProStreamPlayerController.h"

@interface Red5ProStreamPlayerController () {
    R5Configuration *config;
    R5Stream *stream;
}

@end

@implementation Red5ProStreamPlayerController

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    [self setupStreaming];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [self stopStream];
}

//MARK: - Setup Configuratiom and Setup Stream
-(void)setupConfiguration {
    config = [R5Configuration new];
    config.host = self.strHostName;
    config.port = [self.strPort intValue];
    config.contextName = self.strContextName;
    config.licenseKey = self.strLicencekey;
    config.protocol = [self intToR5StreamProtocol:self.protocol];
}


-(void)setupStreaming  {
    R5Connection *connection = [[R5Connection new] initWithConfig:config];
    stream = [[R5Stream new] initWithConnection:connection];
    [self attachStream:stream];
}

- (void)startStream {
    [stream play:self.strStreamName];
}

- (void)stopStream {
    [stream stop];
}

//MARK:- Retrive `Protocol` from int value
-(enum r5_protocol)intToR5StreamProtocol:(NSInteger)protocol {
    switch (protocol) {
        case 0:
            return r5_rtsp;
        case 1:
            return r5_rtsp;
        case 2:
            return r5_srtp;
        case 3:
            return r5_null_srtp;
        default:
            return r5_srtp;
    }
}

@end
