enum R5StreamProtocol {
  RTSP,
  SRTP,
  NullSRTP,
}

class Red5Configuration {
  String licenseKey;
  R5StreamProtocol protocol;
  String host;
  int port;
  String contextName;
  num bufferTime;

  Red5Configuration({
    required this.licenseKey,
    required this.protocol,
    required this.host,
    required this.port,
    this.contextName = 'live',
    this.bufferTime = 1.0,
  });

  Map<String, dynamic> toJson() {
    return {
      'licenseKey': licenseKey,
      'protocol': _protocolToInt(protocol),
      'host': host,
      'port': port,
      'contextName': contextName,
      'bufferTime': bufferTime,
    };
  }

  int _protocolToInt(R5StreamProtocol protocol) {
    switch (protocol) {
      case R5StreamProtocol.RTSP:
        return 0;
      case R5StreamProtocol.SRTP:
        return 1;
      case R5StreamProtocol.NullSRTP:
        return 2;
      default:
        return 0;
    }
  }
}
